import "./style.css";
import { reactive as B, computed as F, onActivated as z, watch as G, ref as H, resolveComponent as p, openBlock as Y, createBlock as j, withCtx as S, createVNode as h, normalizeClass as J, createElementVNode as f, toDisplayString as K, withDirectives as M, vShow as k } from "vue";
import { Grid as Q, GridColumn as W } from "@opentiny/vue";
import { PluginPanel as X, SvgButton as Z } from "@opentiny/tiny-engine-common";
import { constants as $ } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as ee, iconEyeclose as te, IconChevronDown as oe } from "@opentiny/vue-icon";
import { useCanvas as m, useMaterial as ne, useLayout as D } from "@opentiny/tiny-engine-meta-register";
import { extend as re } from "@opentiny/vue-renderless/common/object";
import { typeOf as ce } from "@opentiny/vue-renderless/common/type";
const se = (c, a) => {
  const l = c.__vccOpts || c;
  for (const [o, _] of a)
    l[o] = _;
  return l;
}, { PAGE_STATUS: q } = $, ae = {
  components: {
    TinyGrid: Q,
    TinyGridColumn: W,
    PluginPanel: X,
    SvgButton: Z,
    IconEyeopen: ee(),
    IconEyeclose: te()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup() {
    const { pageState: c, getInstance: a } = m(), { getMaterial: l } = ne(), o = (e) => {
      const r = (i) => (i.forEach((s) => {
        s.show = c.nodesStatus[s.id] !== !1, s.showEye = !s.show;
        const y = s.children;
        ce(y) !== "array" ? delete s.children : s.children.length && r(s.children);
      }), i);
      return [{ ...r([re(!0, {}, e)])[0], componentName: "body" }];
    }, { PLUGIN_NAME: _ } = D(), t = B({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: F(
        () => ![q.Occupy, q.Guest].includes(D().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    });
    z(() => {
      const { getSchema: e } = m().canvasApi.value;
      t.pageSchema = o(e());
    }), G(
      () => c.currentSchema,
      () => {
        const { getSchema: e } = m().canvasApi.value;
        t.pageSchema = o(e());
      }
    );
    const N = () => {
      t.expandAll = !t.expandAll;
    }, A = (e) => {
      e.show = !e.show, c.nodesStatus[e.id] = e.show;
      const { getRenderer: r, clearSelect: i } = m().canvasApi.value;
      r().setCondition(e.id, e.show), i();
    }, b = (e) => e.componentName ? l(e.componentName).icon || "IconAssociation" : void 0, x = (e) => {
      if (t.isLock)
        return;
      const { hoverNode: r } = m().canvasApi.value;
      r(e.id), e.showEye = !0;
    }, I = (e) => {
      e && !e.show || (e.showEye = !1);
    }, L = (e) => {
      if (t.isLock)
        return;
      const { selectNode: r } = m().canvasApi.value;
      r(e == null ? void 0 : e.id, "clickTree");
    }, n = H(null), d = () => {
    }, g = ({ row: e }) => {
      var i;
      return "nav-tree " + (((i = c == null ? void 0 : c.currentSchema) == null ? void 0 : i.id) === e.id ? "high-light-node" : "");
    }, O = (e, r) => {
      var P;
      e.dragged.classList.remove("nodrag");
      const { clientY: i } = r, s = e.draggedRect.bottom, y = Math.abs(i - s), C = e.dragged.querySelector(".tree-box").getAttribute("type"), R = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), w = a(R);
      t.dragState.dragSchema = w;
      const T = e.related.querySelector(".tree-box").getAttribute("type"), U = e.related.querySelector(".tree-box").getAttribute("schemaId"), u = a(U);
      c.hoverVm = u;
      const v = (P = w == null ? void 0 : w.componentName) == null ? void 0 : P.container, V = u == null ? void 0 : u.parent.schema.componentName;
      C === "col" && v && T !== "col" || C === "col" && !v && V !== "row" || C !== "col" && v && T === "row" ? t.dragState.indicator = !1 : u ? t.dragState.indicator = !0 : t.dragState.indicator = !1, t.dragState.indicator ? (e.dragged.classList.remove("nodrag"), t.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), t.dragState.allowDrop = !1);
      const E = r.target;
      y < 4 && y > 1 && v && (!u.schema.children || u.schema.children.length === 0) && (t.dragState.parentNode = E, E.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), t.dragState.parentNode && t.dragState.parentNode.getAttribute("data-rowid") !== E.getAttribute("data-rowid") && (t.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", t.dragState.parentNode = null);
    };
    return G(
      () => c.isLock,
      (e) => {
        setTimeout(d, 1e3), t.isLock = e;
      }
    ), {
      checkElement: L,
      mouseover: x,
      mouseleave: I,
      showNode: A,
      state: t,
      getIcon: b,
      rowDropMove: O,
      gridRef: n,
      toggleTree: N,
      getClassName: g,
      PLUGIN_NAME: _,
      renderIconFn: (e, { isActive: r }) => e(oe(), {
        class: ["tiny-grid-tree__node-btn", { is__active: r }]
      })
    };
  }
}, ie = { class: "tree-wrap lowcode-scrollbar" }, le = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], de = { class: "tree-content" }, ue = ["onMouseup"];
function ge(c, a, l, o, _, t) {
  const N = p("svg-button"), A = p("icon-eyeopen"), b = p("icon-eyeclose"), x = p("tiny-grid-column"), I = p("tiny-grid"), L = p("plugin-panel");
  return Y(), j(L, {
    class: "outlinebox",
    title: "大纲树",
    onClose: a[1] || (a[1] = (n) => c.$emit("close"))
  }, {
    header: S(() => {
      var n, d;
      return [
        h(N, {
          class: J(["item icon-sidebar", [((n = l.fixedPanels) == null ? void 0 : n.includes(o.PLUGIN_NAME.OutlineTree)) && "active"]]),
          tips: (d = l.fixedPanels) != null && d.includes(o.PLUGIN_NAME.OutlineTree) ? "解除固定面板" : "固定面板",
          onClick: a[0] || (a[0] = (g) => c.$emit("fixPanel", o.PLUGIN_NAME.OutlineTree)),
          name: "fixed"
        }, null, 8, ["class", "tips"])
      ];
    }),
    content: S(() => [
      f("div", ie, [
        h(I, {
          ref: "gridRef",
          data: o.state.pageSchema,
          "tree-config": { children: "children", expandAll: o.state.expandAll, renderIcon: o.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": o.getClassName
        }, {
          default: S(() => [
            h(x, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: S((n) => {
                var d;
                return [
                  f("span", {
                    class: "tree-box",
                    schemaId: (d = n.row) == null ? void 0 : d.id,
                    type: n.row.componentName,
                    onMouseover: (g) => o.mouseover(n.row),
                    onMouseleave: (g) => o.mouseleave(n.row),
                    onClick: (g) => o.checkElement(n.row)
                  }, [
                    f("span", de, [
                      f("span", null, K(n.row.componentName), 1)
                    ]),
                    M(f("span", {
                      class: "tree-handle",
                      onMouseup: (g) => o.showNode(n.row)
                    }, [
                      M(h(A, null, null, 512), [
                        [k, n.row.show]
                      ]),
                      M(h(b, null, null, 512), [
                        [k, !n.row.show]
                      ])
                    ], 40, ue), [
                      [k, n.row.showEye]
                    ])
                  ], 40, le)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const pe = /* @__PURE__ */ se(ae, [["render", ge], ["__scopeId", "data-v-5fe8b9c9"]]), me = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, xe = {
  ...me,
  entry: pe
};
export {
  xe as default
};
